// PingerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Pinger.h"
#include "PingerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPingerDlg dialog

CPingerDlg::CPingerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPingerDlg::IDD, pParent),
	m_iTimerID(-1)
{
	//{{AFX_DATA_INIT(CPingerDlg)
	m_strURL = _T("www.endurasoft.com");
	m_bSuspend = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPingerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPingerDlg)
	DDX_Control(pDX, IDC_RATESPIN, m_CRateSpin);
	DDX_Text(pDX, IDC_URLTXT, m_strURL);
	DDX_Check(pDX, IDC_SUSPEND, m_bSuspend);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPingerDlg, CDialog)
	//{{AFX_MSG_MAP(CPingerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_PINGNOW, OnPingnow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPingerDlg message handlers

BOOL CPingerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Establish spinner bounds
	m_CRateSpin.SetRange(20,60);
	m_CRateSpin.SetPos(30);
	m_CRateSpin.Invalidate();

	// Start the timer...first pass is a 1 second delay
	// before first ping.  :)
	m_iTimerID = SetTimer(1,1000,NULL);

	// Check for problems
	if ( m_iTimerID == -1 ) {
		int iResponse = AfxMessageBox(IDS_E_NOTIMER,MB_YESNO|MB_ICONERROR);
		if ( iResponse == IDNO ) EndDialog(-1);
	} // if

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPingerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPingerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPingerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CPingerDlg::CreatePing()
{
	// Get the URL
	UpdateData(TRUE);
	CString strCmd;
	strCmd.Format(IDS_PINGCMD,m_strURL);
	TCHAR strCmdLine[MAX_PATH+1] = {0};
	_tcsncpy(strCmdLine,strCmd,MAX_PATH);

	// Create the ping process and wait for a quit
	STARTUPINFO si = {0};
	si.cb = sizeof(si);
	si.wShowWindow = SW_HIDE;

	BOOL bCreated = CreateProcess(NULL,strCmdLine,
									NULL,NULL,
									FALSE,DETACHED_PROCESS,
									NULL,NULL,
									&si,&m_pi);

	// Check for problems...
	if ( !bCreated ) {
		int iResponse = AfxMessageBox(IDS_E_NOPROCESS,MB_YESNO|MB_ICONERROR);
		if ( iResponse == IDNO ) EndDialog(-1);
	} // if

	return bCreated;
}

void CPingerDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// Kill timer
	if ( m_iTimerID != -1 ) KillTimer(m_iTimerID);
}

void CPingerDlg::DoPing()
{
	// Kill the timer
	KillTimer(m_iTimerID);
	m_iTimerID = -1;

	// Disable the cancel and ping buttons
	CWnd* pBtn = GetDlgItem(IDCANCEL);
	ASSERT(pBtn);
	pBtn->EnableWindow(FALSE);
	pBtn = GetDlgItem(IDC_PINGNOW);
	ASSERT(pBtn);
	pBtn->EnableWindow(FALSE);

	// Create the ping process
	CreatePing();

	// Wait for it to complete
	if ( WaitForSingleObject(m_pi.hProcess,60000) == WAIT_TIMEOUT ) {
		// Error: hung process, so kill it
		TerminateProcess(m_pi.hProcess,-1);

		// Ask to continue (we already killed the ping...)
		int iResponse = AfxMessageBox(IDS_E_HUNGPING,MB_YESNO|MB_ICONERROR);
		if ( iResponse == IDNO ) {
			EndDialog(-1);
			return;
		} // if
	} // if

	// Enable the cancel button
	pBtn = GetDlgItem(IDCANCEL);
	ASSERT(pBtn);
	pBtn->EnableWindow(TRUE);
	pBtn = GetDlgItem(IDC_PINGNOW);
	ASSERT(pBtn);
	pBtn->EnableWindow(TRUE);

	// Start the timer
	m_iTimerID = SetTimer(1,m_CRateSpin.GetPos()*1000,NULL);

	// Check for problems
	if ( m_iTimerID == -1 ) {
		int iResponse = AfxMessageBox(IDS_E_NOTIMER,MB_YESNO|MB_ICONERROR);
		if ( iResponse == IDNO ) EndDialog(-1);
	} // if
}

void CPingerDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);

	// Do the ping, if not suspended
	UpdateData(TRUE);
	if ( !m_bSuspend ) DoPing();
}

void CPingerDlg::OnPingnow() 
{
	// Do the ping
	DoPing();
}
