// maindlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDLG_H__DC16127C_44F9_4BCF_BDAB_52E20D803699__INCLUDED_)
#define AFX_MAINDLG_H__DC16127C_44F9_4BCF_BDAB_52E20D803699__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMainDlg : public CAxDialogImpl<CMainDlg>, CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler
{
public:
	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		return IsDialogMessage(pMsg);
	}

	virtual BOOL OnIdle()
	{
		return FALSE;
	}

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER(IDC_PINGNOW, OnPingNow)
		MESSAGE_HANDLER(WM_SYSCOMMAND, OnSysCommand)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
	END_MSG_MAP()

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// center the dialog on the screen
		CenterWindow();

		// set icons
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);
		HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
		SetIcon(hIconSmall, FALSE);

		// Add "About..." menu item to system menu.

		// IDM_ABOUTBOX must be in the system command range.
		_ASSERTE((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
		_ASSERTE(IDM_ABOUTBOX < 0xF000);

		CMenu SysMenu = GetSystemMenu(FALSE);
		if(::IsMenu(SysMenu))
		{
			TCHAR szAboutMenu[256];
			if(::LoadString(_Module.GetResourceInstance(), IDS_ABOUTBOX, szAboutMenu, 255) > 0)
			{
				SysMenu.AppendMenu(MF_SEPARATOR);
				SysMenu.AppendMenu(MF_STRING, IDM_ABOUTBOX, szAboutMenu);
			}
		}
		SysMenu.Detach();

		// register object for message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		UIAddChildWindowContainer(m_hWnd);

		// Subclass and initialize the controls
		m_CURL.Attach(GetDlgItem(IDC_URLTXT));
		m_CURL.SetLimitText(MAX_PATH);
		m_CURL.SetWindowText("www.endurasoft.com");

		m_CRateSpin.Attach(GetDlgItem(IDC_RATESPIN));
		m_CRateSpin.SetRange(20,60);
		m_CRateSpin.SetPos(30);
		m_CRateSpin.Invalidate();

		// Start the timer...first pass is a 1 second delay
		// before first ping.  :)
		m_iTimerID = SetTimer(1,1000);

		// Check for problems
		if ( m_iTimerID == -1 ) {
			// Couldn't get a timer, so ask to continue...user
			// will have to ping at will using "Ping Now" button.
			TCHAR szErrMsg[MAX_PATH];
			if( ::LoadString(_Module.GetResourceInstance(),IDS_E_NOTIMER,szErrMsg,MAX_PATH ) > 0) {
				// Error string loaded, so display error message
				int iResponse = MessageBox(szErrMsg,"Error!",MB_YESNO|MB_ICONERROR);
				if ( iResponse == IDNO ) EndDialog(-1);
			} // if
		} // if

		return TRUE;
	}

	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CAboutDlg dlg;
		dlg.DoModal();
		return 0;
	}

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		// TODO: Add validation code 
		CloseDialog(wID);
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CloseDialog(wID);
		return 0;
	}

	void CloseDialog(int nVal)
	{
		// Kill timer
		if ( m_iTimerID != -1 ) KillTimer(m_iTimerID);

		// Take down the dialog
		DestroyWindow();
		::PostQuitMessage(nVal);
	}

	LRESULT OnSysCommand(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
	{
		UINT uCmdType = (UINT)wParam;

		if((uCmdType & 0xFFF0) == IDM_ABOUTBOX)
		{
			CAboutDlg dlg;
			dlg.DoModal();
		}
		else
			bHandled = FALSE;

		return 0;
	}

	LRESULT OnPingNow(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		// Do the ping
		DoPing();

		return 0;
	}

	LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// Check status of suspend checkbox, and if not
		// suspended, ping
		if ( IsDlgButtonChecked(IDC_SUSPEND) == BST_UNCHECKED ) DoPing();

		return 0;
	}

	// Helpers
protected:
	BOOL CreatePing()
	{
		// Get the command line formatting string
		TCHAR szCmd[MAX_PATH+1] = {0};
		::LoadString(_Module.GetResourceInstance(),IDS_PINGCMD,szCmd,MAX_PATH);

		// Get the URL
		TCHAR szURL[MAX_PATH+1] = {0};
		m_CURL.GetWindowText(szURL,MAX_PATH);

		// Formulate a command line
		TCHAR szCmdLine[(2*MAX_PATH)+1] = {0};
		wsprintf(szCmdLine,szCmd,szURL);

		// Create the ping process and wait for a quit
		STARTUPINFO si = {0};
		si.cb = sizeof(si);
		si.wShowWindow = SW_HIDE;

		BOOL bCreated = CreateProcess(NULL,szCmdLine,
										NULL,NULL,
										FALSE,DETACHED_PROCESS,
										NULL,NULL,
										&si,&m_pi);

		// Check for problems...
		if ( !bCreated ) {
			// Could not create the process
			TCHAR szErrMsg[MAX_PATH];
			if( ::LoadString(_Module.GetResourceInstance(),IDS_E_NOPROCESS,szErrMsg,MAX_PATH ) > 0) {
				// Error string loaded, so display error message
				int iResponse = MessageBox(szErrMsg,"Error!",MB_YESNO|MB_ICONERROR);
				if ( iResponse == IDNO ) EndDialog(-1);
			} // if
		} // if

		return bCreated;
	}

	void DoPing()
	{
		// Kill the timer
		KillTimer(m_iTimerID);
		m_iTimerID = -1;

		// Disable the cancel and ping buttons
		CWindow wCancelBtn(GetDlgItem(IDCANCEL));
		wCancelBtn.EnableWindow(FALSE);
		CWindow wPingNowBtn(GetDlgItem(IDC_PINGNOW));
		wPingNowBtn.EnableWindow(FALSE);

		// Create the ping process
		CreatePing();

		// Wait for it to complete
		if ( WaitForSingleObject(m_pi.hProcess,60000) == WAIT_TIMEOUT ) {
			// Error: hung process, so kill it
			TerminateProcess(m_pi.hProcess,-1);

			// Ask to continue (we already killed the ping...)
			TCHAR szErrMsg[MAX_PATH];
			if( ::LoadString(_Module.GetResourceInstance(),IDS_E_HUNGPING,szErrMsg,MAX_PATH ) > 0) {
				// Error string loaded, so display error message
				int iResponse = MessageBox(szErrMsg,"Error!",MB_YESNO|MB_ICONERROR);
				if ( iResponse == IDNO ) {
					EndDialog(-1);
					return;
				} // if
			} // if
		} // if

		// Enable the cancel and ping buttons
		wCancelBtn.EnableWindow(TRUE);
		wPingNowBtn.EnableWindow(TRUE);

		// Start the timer
		m_iTimerID = SetTimer(1,m_CRateSpin.GetPos()*1000);

		// Check for problems
		if ( m_iTimerID == -1 ) {
			// Couldn't get the timer...
			TCHAR szErrMsg[MAX_PATH];
			if( ::LoadString(_Module.GetResourceInstance(),IDS_E_NOTIMER,szErrMsg,MAX_PATH ) > 0) {
				// Error string loaded, so display error message
				int iResponse = MessageBox(szErrMsg,"Error!",MB_YESNO|MB_ICONERROR);
				if ( iResponse == IDNO ) EndDialog(-1);
			} // if
		} // if
	}

	// Attributes
	UINT m_iTimerID;
	PROCESS_INFORMATION m_pi;

	// Controls
	CContainedWindowT<WTL::CEdit> m_CURL;
	CContainedWindowT<WTL::CUpDownCtrl> m_CRateSpin;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__DC16127C_44F9_4BCF_BDAB_52E20D803699__INCLUDED_)
